VramAdress = 0
Size = 0
BankNumber = 2
TileAddress = 4



start_tile_uploader:
  rep #$30	; A=16, X/Y=16
  ldx #$0000
  lda #$1801			; Set DMA mode (word, normal increment) and destination register (VRAM write register)
  sta $4300
  lda #$0080
  sta $2115

  lda 16x16RequestCounter
  beq tile_uploader_32x32_start

  lda #$0040
  sta $4305
  sta $4315

;16x16 Top Half
  lda 16x16TileRequestTable+VramSpot,x
  sta $2116

  lda 16x16TileRequestTable+BankNumber,x
  sta $4303
  sta $4313

  lda 16x16TileRequestTable+TileAddress,x
  sta $4302
  clc
  adc #$0040
  sta $4312

  lda #%0000000100000000	; Initiate DMA transfer (channel 0)
  sta $420A


;16x16 Bottom Half
  lda 16x16TileRequestTable+VramSpot,x
  clc
  adc #$0100
  sta $2116

  lda #%0000001000000000	; Initiate DMA transfer (channel 1)
  sta $420A

  txa
  clc
  adc #$0006
  tax
  cpx 16x16TileRequestCounter
  bne tile_uploader_16x16


tile_uploader_32x32_start:
  lda 32x32RequestCounter
  beq done

  lda #$0080
  sta $4305
  sta $4315
  sta $4325
  sta $4335

tile_uploader_32x32:
  lda 32x32TileRequestTable+VramAdress,x
  sta $2116

  lda 32x32TileRequestTable+BankNumber,x
  sta $4303
  sta $4313
  sta $4323
  sta $4333

  lda 32x32TileRequestTable+TileAddress,x
  sta $4302
  clc
  adc #$0040
  sta $4312
  clc
  adc #$0040
  sta $4322
  clc
  adc #$0040
  sta $4332

  lda #%0000000100000000	; Initiate DMA transfer (channel 0)
  sta $420A


;Second Row
  lda 32x32TileRequestTable+VramAdress,x
  clc
  adc #$0100
  sta $2116

  lda #%0000001000000000	; Initiate DMA transfer (channel 1)
  sta $420A


;Third Row
  lda 32x32TileRequestTable+VramAdress,x
  clc
  adc #$0200
  sta $2116

  lda #%0000010000000000	; Initiate DMA transfer (channel 2)
  sta $420A


;Fourth Row
  lda 32x32TileRequestTable+VramAdress,x
  clc
  adc #$0300
  sta $2116

  lda #%0000100000000000	; Initiate DMA transfer (channel 3)
  sta $420A

  txa
  clc
  adc #$0006
  cmp 32x32TileRequestCounter
  beq done
  tax
  bra tile_uploader_32x32

done:
  rts